<?php

namespace Database;
use Model\CoachAthlete;
use Model\User;
use \PDO;
use \DateTime;
use Model\Role;
use Model\Coach;
use Shared\Log;

class CoachMapper {
    public function coachSqlToEntity(array $data): array {
        $coachEntities = [];

        foreach ($data as $coachData) {
            $coach = new CoachEntity();

            if (isset($coachData['idAthlete'])) {
                $coach->setIdCoach($coachData['idAthlete']);
            }

            if (isset($coachData['nom'])) {
                $coach->setNom($coachData['nom']);
            }

            if (isset($coachData['prenom'])) {
                $coach->setPrenom($coachData['prenom']);
            }

            if (isset($coachData['username'])) {
                $coach->setUsername($coachData['username']);
            }

            if (isset($coachData['email'])) {
                $coach->setEmail($coachData['email']);
            }

            if (isset($coachData['sexe'])) {
                $coach->setSexe($coachData['sexe']);
            }

            if (isset($coachData['taille'])) {
                $coach->setTaille($coachData['taille']);
            }

            if (isset($coachData['poids'])) {
                $coach->setPoids($coachData['poids']);
            }

            if (isset($coachData['motDePasse'])) {
                $coach->setMotDePasse($coachData['motDePasse']);
            }

            if (isset($coachData['dateNaissance'])) {
                $coach->setDateNaissance($coachData['dateNaissance']);
            }

            if (isset($coachData['isCoach'])) {
                $coach->setIsCoach($coachData['isCoach']);
            }

            $coachEntities[] = $coach;
        }

        return $coachEntities;
    }

    public function map(array $data) {
        $coach = new CoachEntity();
        $coach->setIdCoach($data['idCoach']);
        $coach->setNom($data['nom']);
        $coach->setUsername($data['username']);
        $coach->setPrenom($data['prenom']);
        $coach->setEmail($data['email']);
        $coach->setSexe($data['sexe']);
        $coach->setTaille($data['taille']);
        $coach->setPoids($data['poids']);
        $coach->setMotDePasse($data['motDePasse']);
        $coach->setDateNaissance($data['dateNaissance']);
        $coach->setIsCoach($data['isCoach']);

        return $coach;
    }

    public function CoachEntityToModel(CoachEntity $coachEntity):User{
        $role = new CoachAthlete();
        $date = new DateTime($coachEntity->getDateNaissance());

        $user = new User(
            $coachEntity->getNom(),
            $coachEntity->getPrenom(),
            $coachEntity->getUsername(),
            $coachEntity->getEmail(),
            $coachEntity->getMotDePasse(),
            $coachEntity->getSexe(),
            $coachEntity->getTaille(),
            $coachEntity->getPoids(),
            $date,
            $role
        );

        return $user;
    }

    public function CoachToEntity(User $user):CoachEntity{

        $coach = new CoachEntity();
        $coach->setIdCoach($user->getId());
        $coach->setNom($user->getNom());
        $coach->setPrenom($user->getPrenom());
        $coach->setEmail($user->getEmail());
        $coach->setSexe($user->getSexe());
        $coach->setTaille($user->getTaille());
        $coach->setPoids($user->getPoids());
        $coach->setMotDePasse($user->getMotDePasse());
        $coach->setDateNaissance($user->getDateNaissance());

        return $coach;
    }
}

?>
